-- +------------------------------------------------------------------------------+
-- |                                                                              |
-- |		                      WWWWWQ                                          |
-- |		                    9M..~;iTMk                                        |
-- |		                  kM~.  ..,~ioMk                                      |
-- |		                kM=.  ``,"<=vhWK                'MMMMMv               |
-- |		              vM=.  ``,,_~v7jUWK                `***aWY               |
-- |		            vMY.  ``:,__<!jy@K.`              'MMMD=SWY               |
-- |		          /MY.` ``',__<<vn@$.`               M8,<W@MP.`               |
-- |		        /Mh.`  `',__^<vvjFSEMk             MM,~<vWp.`                 |
-- |		      'Mh.`  `-,__|<lvjj@NJCSUMk   vMMMMMMM,,<vM8.`                   |
-- |		    'M#.`  `-,__|<cvxj@@sT<^:/SUMMMS~=*8W^_<<M@WQ                     |
-- |		   M#.`  `.,__;<cvzj%@ss7c'':~>oW5~/+6Ml_^<MMW&.`                     |
-- |		 MMWWMMMU,,_;<rvzj$@es77<^::'?MA~/+GMv,/<&MWW*YM9                     |
-- |		 WW8RSnioM6<rvCj$@XsJ7<<''';Mb~|+GMS,/<6MWW**=<~,                     |
-- |		 WW!!>^,,"vMMMS"?sr<,:,,-;MQ*eMK'|*KMMM!.&Wll__::'?MMMMMMM/           |
-- |		 ..Mg `'':vW5~,'|<"'::'':,~=Mb,lMMM@WWWMM~-,,:::::;*aWWWWW<           |
-- |		   WQ   `':~,''::'::''::';M8,lM4-:~~~~~~~:':::::::~=SWWWWW<           |
-- |		   .~M9   `'':''::''::'':^W%<oW@MMMh+++++,::::::::~=SWWWWW<           |
-- |		     .~Mk   `'':''::''::.~WWMP..':"SMMMMMv++++++^:~=SWWWWW<           |
-- |		       .=Mk   `'::''::..  ....`.-':|i8Wi.8MMMMMM&+>=SWWWWW<           |
-- |		         .=Mv   .'::..  ``  `.-':~^*1QW< `......~MMM@WWWWW<           |
-- |		           .YMv   `.  ``  ``-':~^*16@!.          ...iWWWWW<           |
-- |		            `.YM/   ``    -':~^i16@j.                .....            |
-- |	   	           `.hM/     `.:,^i1K@j.`                                     |
-- |		              vMGsmM' ``-:^>1K@K.`                                    |
-- |		            vMOsT7$W"`--:~1e@K.`                                      |
-- |	    	      /MOsl<~:"~8M^^zl``.`                                        |
-- |		          <WK<~'::` QW11@8                                            |
-- |		           .xM2:` -:&W@@.`                                            |
-- |	    	        `.)MMMMMWW..            	                              |
-- |                                                                              |
-- | PNG To icns                                                                  |
-- | Versione 2.0 (Per Mac OS X 10.8.x e successivi, icone @2x)                   |
-- | mORA (mora@roam.it) - www.roam.it/soft                                       |
-- +------------------------------------------------------------------------------+
-- | Parti da Extract App Resource Icons di Ben Waldie ben@automatedworkflows.com |
-- | http://www.automatedworkflows.com                                            |
-- +--^---------------------------------------------------------------------------+
-- |/ ! \ Revisioni                                                               |
-- +-----+------------------------------------------------------------------------+
-- | DEV | 20131226 1229
-- +-----+------------------------------------------------------------------------+
-- | R | 20160519 1538 - Ricompilato per per OS X 10.1x
-- | R | 20191204 1926 - Crea da solo il set di PNG necessarie attraverso sips via Image Events
-- | R | 20211205 2025 - macOS 12.x Monterey
-- +--^---------------------------------------------------------------------------+
-- |/ ! \ Documentazione                                                          |
-- +-----+------------------------------------------------------------------------+
-- | http://developer.apple.com/library/mac/#documentation/GraphicsAnimation/Conceptual/HighResolutionOSX/Optimizing/Optimizing.html
-- +------------------------------------------------------------------------------+
-- | Supposto che si abbiano a disposizone le seguenti imamgini .png:
-- |   16 |   32 |   64 |  128 |  256 |  512 | 1024 | le icone 1x e 2x sono:
-- |    + |    + |    - |    + |    + |    + |    - | @1x
-- |    - |    + |    + |    - |    + |    + |    + | @2x
-- +------------------------------------------------------------------------------+

-- +-----+------------------------------------------------------------------------+
-- | BGN | Algoritmo principale                                                   |
--on open aDroppedFolders -- (Droplet)
set standardPngSet to {"16", "32", "64", "128", "256", "512", "1024"} -- set standard di .png per creare un iconset completo
set pngNormalSizes to {"16", "32", "128", "256", "512"} -- dimensioni delle .png per uso normale (@1x)
set pngRetinaSizes to {"32", "64", "256", "512", "1024"} -- dimensioni delle .png per uso Retina (@2x)
set fileExtension to ".png" -- estensione del file (".png")
--	repeat with i from 1 to the count of aDroppedFolders (Droplet)

set aFolder to choose folder default location (path to desktop) -- Chiede di scegliere la finestra radice 
--	set aFolder to item i of aDroppedFolders -- cartella scelta (Droplet)

tell application "System Events" -- Per prima cosa vediamo se nella cartella ci sono immagini (dovrebbe essercene una)
	set aFolderPath to (path of aFolder) as string -- percoso della cartella scelta
	set theOutputFolder to aFolderPath -- la carella scelta sar anche la cartella destinazione
	set originalImageFiles to path of every file of folder aFolderPath where its name extension = "png" as string -- copia il contenuto della cartella scelta in un vettore
end tell

-- +-----+------------------------------------------------------------------------+
-- | BGN | Crea le imamgini scalate a partire da quella presente                  |
repeat with k from 1 to the count of originalImageFiles
	set scaleByPercentage to false -- volendo scalare in percentuale basta mettere questo parametro a true
	
	repeat with j from 1 to the count of standardPngSet -- per tutte le dimensioni desiderate...
		tell application "Image Events" -- Image Events --> sips
			launch
			set theImage to open item k of originalImageFiles -- apre l'immagine
			set theSaveName to (item j of standardPngSet as string) & ".png" -- compone il nome delle immagini da salvare con la dimensione + ".png"
			
			tell theImage
				if scaleByPercentage = true then -- se si  sceltro di scalare l'imamgine in percentuale...
					scale by factor 0.5 -- ... modificare il fattore di scala, qui non utilizzato...
				else -- ... altrimenti ...
					set theDimension to item j of standardPngSet as number -- ... la si scala in termini assoluti (px)...
					scale to size theDimension -- ... theDimension  un numero, preso dal vettore standardPngSet, che indica il valore finale del lato pi lungo (l'altro in proporzione): qui  un quadrato
				end if
				
				save as PNG in (theOutputFolder & theSaveName) -- salva l'immagine scalata...
				close -- ... e chiude l'immagine originale senza modificarla.
			end tell
		end tell
	end repeat
end repeat
-- | END | Crea le imamgini scalate a partire da quella presente                  |
-- +-----+------------------------------------------------------------------------+
-- | BGN | Copia le imamgini nell'iconset                                         |
tell application "System Events" -- ora creiamo l'iconset con le immagini che abbiamo creato al passo precedente
	set iconsetName to name of aFolder & ".iconset" -- nome della cartella per l'iconset
	set pngList to name of every file of folder aFolderPath where its name extension = "png" -- copia il contenuto della cartella scelta in un vettore
end tell

if pngList = {} then -- se il vettore  vuoto...
	debug("Nessun file utile in " & (name of aFolder) & ".") of me -- ... avverte...
	return -- ... ed esce.
end if

set theOutputFolder to createOutputFolder(iconsetName, aFolderPath) -- Crea la cartella per l'iconset

repeat with a from 1 to length of standardPngSet
	set currentPng to item a of standardPngSet -- ad esempio: 16
	set currentPngFileName to currentPng & fileExtension -- ad esempio: 16.png
	
	tell application "System Events"
		if ((aFolder & currentPngFileName as string) exists) is false then -- Contrtolla che la .png corrente ci sia, se no...		
			debug(currentPngFileName & " non trovato") of me -- ... avverte...
			return -- ... ed esce.
		end if
	end tell -- application "System Events"
	
	-- +-----+------------------------------------------------------------------------+
	-- | BGN | Copia le imamgini @1x                                                  |
	if (currentPng is in pngNormalSizes) is true then -- ad esempio: 32
		set newFileName to ("icon_" & currentPng & "x" & currentPng & fileExtension) as string -- 16.png -> icon_16x16.png
		
		tell application "Finder"
			set theResult to duplicate (aFolder & currentPngFileName as string) to theOutputFolder with replacing -- /out/16.png
			set name of theResult to newFileName -- /out/icon_16x16.png
		end tell -- application "Finder"
	end if
	-- | END | Copia le imamgini @1x                                                  |
	-- +-----+------------------------------------------------------------------------+
	-- | BGN | Copia le imamgini @2x                                                  |
	if (currentPng is in pngRetinaSizes) is true then -- ad esempio: 32
		set halfSizeCurrentPng to (currentPng / 2 as integer) -- 32 / 2 = 16
		set newFileName to ("icon_" & halfSizeCurrentPng & "x" & halfSizeCurrentPng & "@2x" & fileExtension) as string -- icon_16x16@2x.png
		
		tell application "Finder"
			set theResult to duplicate (aFolder & currentPngFileName as string) to theOutputFolder with replacing
			set name of theResult to newFileName -- /out/icon_16x16@2x.png
		end tell
	end if
	-- | END | Copia le imamgini @2x                                                  |
	-- +-----+------------------------------------------------------------------------+
	
end repeat
-- | END | Copia le imamgini nell'iconset                                         |
-- +-----+------------------------------------------------------------------------+
-- | BGN | Crea l'.icns                                                           |
set vAPOSIXFolder to POSIX path of theOutputFolder -- ottiene il percorso POSIX alla cartella (che altrimenti sarebbe in formato Apple e non interpretabile da Terminal)
do shell script "iconutil -c icns " & quoted form of vAPOSIXFolder -- usa iconutil per creare l'icona (.icns)
-- | END | Crea l'.icns                                                           |
-- +-----+------------------------------------------------------------------------+
--end open -- aDroppedFolders (Droplet)
-- | END | Algoritmo principale                                                   |
-- +-----+------------------------------------------------------------------------+

-- +-----+------------------------------------------------------------------------+
-- | BGN | Cartella di output                                                     |
on createOutputFolder(theFolderName, theOutputFolder)
	tell application "System Events"
		if (folder theFolderName of folder theOutputFolder exists) then
			return path of (folder theFolderName of folder theOutputFolder)
		else
			return path of (make new folder at folder theOutputFolder with properties {name:theFolderName})
		end if
	end tell
end createOutputFolder
-- | END | Cartella di output                                                     |
-- +-----+------------------------------------------------------------------------+

-- +-----+------------------------------------------------------------------------+
-- | BGN | DEBUG                                                                  |
on debug(vErrorString)
	display alert "/!\\ - DEBUG" message vErrorString as warning
end debug
-- | END | DEBUG                                                                  |
-- +-----+------------------------------------------------------------------------+